#!/bin/sh
#
#
. ./proc-helper
#
release_ver="1.2.0~202209"

echo "*****************************************"
echo "*** Script zur Anpassung der Firmware ***"
echo "*****************************************"
echo

check=`cat /lib/gluon/release | grep $release_ver`
if [ "$check" == "" ]
then
###########################################
echo
echo "Dieses Patch ist fuer diese Version der Firmware NICHT geeignet!"
echo
echo "Bitte eine passende Version herunterladen (falls ueberhaupt ein Patch erforderlich ist) und"
echo "diese dann ausfuehren ..."
echo
###########################################
else
###########################################
echo "-> passe Config-Vorgaben an ffhal an..."
###########################################
ffhal_params_and_files

##3xuci set gluon-setup-mode.@setup_mode[0].configured='1'
echo

###########################################
##32echo "-> setze Netzwerk-Parameter zu ffhal..."
###########################################
##32echo -n "."; uci set fastd.sample_config.mtu='1426'
##32echo -n "."; uci set fastd.mesh_vpn.mtu='1426'
##32echo -n "."; uci set network.mesh_vpn.mtu='1426'
##32echo -n "."; uci set network.local_node_dev.macaddr='02:dd:9e:0b:50:1c'
##32echo -n "."; uci set network.local_node.ipaddr='10.62.0.100/16'
##32echo -n "."; uci set network.local_node.ip6addr='fd0f:8db3:d50a::100/128'
##32echo -n "."; uci set network.local_node_route6.target='fd0f:8db3:d50a::/64'
##nowdate=`date -u +"%Y %m %d %H %M"`
##set -- `echo $nowdate`
##yr=$1; mn=$2; dy=$3; hr=$4; mi=$5
##echo "8"; uci set system.@system[0].hostname="ffhal-CPE210v3-$yr$mn$dy$hr$mi"
##32devdata=`ip a s dev eth0`; set -- `echo $devdata`; devdata=`echo $15`; devdata=`echo $devdata | sed  's/://g'`
###echo "8"; uci set system.@system[0].hostname="ffhal-CPE210v3-adaptiert"
##32echo "ok";   uci set system.@system[0].hostname="ffhal-$devdata"
##32echo

###########################################
##3yecho "-> passe weitere Netzwerkeintrge an..."
###########################################
##32echo -n "."; uci set network.mesh_radio0=interface
##32echo -n "."; uci set network.mesh_radio0.proto='gluon_mesh'
##3yecho -n "."; uci del network.mesh_wan.index
##3yecho -n "."; uci set network.mesh_wan.auto='0'
##3yecho -n "."; uci set network.mesh_wan.fixed_mtu='1'
##3yecho -n "."; uci set network.mesh_wan.proto='gluon_mesh'
##3yecho -n "."; uci del network.client.ra_holdoff
##3yecho -n "."; uci del network.gluon_bat0.gw_mode
##3yecho "ok";   uci set network.mesh_wan.disabled='1'

##3yuci commit
##3yecho

##########################################
# bermittlung der Infos an die Seite
# passiert in Halle mit respondd,
# allerdings funktioniert das mit der
# Version vom Image nicht
#
# Update:
# das war ein Irrtum. Eine Anpassung der
# Parameter beim internen Aufruf behebt das
##########################################
echo "-> kopiere Dateien von respondd..."
###########################################
respondd_files
echo

###########################################
# for debug...                            #
###########################################
# echo "21S"; uci set fastd.mesh_vpn.secret='10c0ac0a49bed094c6b1f1eda54fc73efc3c5ff36834028c4dc2ee8ce5414b47'
###########################################

uci commit
echo

###########################################
##32echo "-> setze Modus als Knoten..."
###########################################
##32uci set gluon-node-info.@system[0].role='node'

##32uci commit gluon-node-info

##32echo

##3x###########################################
##3xecho "-> passe ssid changer an..."
##3x###########################################
# uci set ssid-changer.settings=main
##3xecho -n "touching..."; touch /etc/config/ssid-changer

##3xecho -n "."; uci set ssid-changer.settings=settings
##3xecho -n "."; uci set ssid-changer.settings.enabled='1'
##3xecho -n "."; uci set ssid-changer.settings.tq_limit_max='45'
##3xecho -n "."; uci set ssid-changer.settings.suffix='nodename'
##3xecho -n "."; uci set ssid-changer.settings.tq_limit_min='35'
##3xecho -n "."; uci set ssid-changer.settings.switch_timeframe='15'
##3xecho -n "."; uci set ssid-changer.settings.tq_limit_enabled='0'
##3xecho -n "."; uci set ssid-changer.settings.first='5'
##3xecho "ok";   uci set ssid-changer.settings.prefix='Offline_www.freifunk-halle.org_'

##3xuci commit

###########################################
# uci set uhttpd.defaults.commonname='LEDE'
##3xecho

###########################################
echo "-> passe ntp Einstellungen an..."
###########################################
echo -n "."; uci del system.ntp.server

# echo -n "."; uci add_list system.ntp.server='time1.service.ffhal'
# echo -n "."; uci add_list system.ntp.server='time2.service.ffhal'
echo -n "."; uci add_list system.ntp.server='fd0f:8db3:d50a:0:208:a1ff:fe25:cf0a'
echo -n "."; uci add_list system.ntp.server='131.188.3.220'
echo -n "."; uci add_list system.ntp.server='131.188.3.221'
echo -n "."; uci add_list system.ntp.server='131.188.3.222'
echo -n "."; uci add_list system.ntp.server='192.53.103.108'
echo "ok";

uci commit
echo

###########################################
echo "-> passe LED-Steuerung an..."
###########################################
echo -n "."; uci set system.led_rssilow=led
echo -n "."; uci set system.led_rssilow.sysfs='tp-link:green:link1'
echo -n "."; uci set system.led_rssilow.trigger='rssi'
echo -n "."; uci set system.led_rssilow.iface='rssid_wlan0'
echo -n "."; uci set system.led_rssilow.minq='1'
echo -n "."; uci set system.led_rssilow.maxq='100'
echo -n "."; uci set system.led_rssilow.offset='0'
echo -n "."; uci set system.led_rssilow.factor='13'

echo -n "."; uci set system.led_rssimediumlow=led
echo -n "."; uci set system.led_rssimediumlow.sysfs='tp-link:green:link2'
echo -n "."; uci set system.led_rssimediumlow.trigger='rssi'
echo -n "."; uci set system.led_rssimediumlow.iface='rssid_wlan0'
echo -n "."; uci set system.led_rssimediumlow.minq='22'
echo -n "."; uci set system.led_rssimediumlow.maxq='100'
echo -n "."; uci set system.led_rssimediumlow.offset='-21'
echo -n "."; uci set system.led_rssimediumlow.factor='13'

echo -n "."; uci set system.led_rssimediumhigh=led
echo -n "."; uci set system.led_rssimediumhigh.sysfs='tp-link:green:link3'
echo -n "."; uci set system.led_rssimediumhigh.trigger='rssi'
echo -n "."; uci set system.led_rssimediumhigh.iface='rssid_wlan0'
echo -n "."; uci set system.led_rssimediumhigh.minq='43'
echo -n "."; uci set system.led_rssimediumhigh.maxq='100'
echo -n "."; uci set system.led_rssimediumhigh.offset='-42'
echo -n "."; uci set system.led_rssimediumhigh.factor='13'

echo -n "."; uci set system.led_rssihigh=led
echo -n "."; uci set system.led_rssihigh.sysfs='tp-link:green:link4'
echo -n "."; uci set system.led_rssihigh.trigger='rssi'
echo -n "."; uci set system.led_rssihigh.iface='rssid_wlan0'
echo -n "."; uci set system.led_rssihigh.maxq='100'
echo -n "."; uci set system.led_rssihigh.factor='13'
echo -n "."; uci set system.led_rssihigh.minq='64'
echo -n "."; uci set system.led_rssihigh.offset='-63'

echo -n "."; uci set system.led_lan=led
echo -n "."; uci set system.led_lan.name='LAN'
echo -n "."; uci set system.led_lan.sysfs='tp-link:green:lan0'
echo -n "."; uci set system.led_lan.trigger='netdev'
echo -n "."; uci set system.led_lan.mode='link tx rx'
echo "ok";   uci set system.led_lan.dev='eth0'

echo -n "RSSI LEDs: "; /etc/init.d/rssileds reload
echo "....ok"
echo -n "LAN LED  : "; /etc/init.d/led reload
#echo "....ok"

uci commit
echo

###########################################
echo "-> DAC524's Workaround wegen mesh0..."
###########################################
dac524_files

echo
###########################################
echo "-> passe WLAN Einstellungen an..."
###########################################
# uci del wireless.radio0.legacy_rates

echo -n "."; uci del wireless.radio0.supported_rates 2> /dev/null

echo -n "."; uci add_list wireless.radio0.supported_rates='6000'
echo -n "."; uci add_list wireless.radio0.supported_rates='9000'
echo -n "."; uci add_list wireless.radio0.supported_rates='12000'
echo -n "."; uci add_list wireless.radio0.supported_rates='18000'
echo -n "."; uci add_list wireless.radio0.supported_rates='24000'
echo -n "."; uci add_list wireless.radio0.supported_rates='36000'
echo -n "."; uci add_list wireless.radio0.supported_rates='48000'
echo -n "."; uci add_list wireless.radio0.supported_rates='54000'

echo -n "."; uci del wireless.radio0.basic_rate 2> /dev/null

echo -n "."; uci add_list wireless.radio0.basic_rate='6000'
echo -n "."; uci add_list wireless.radio0.basic_rate='9000'
echo -n "."; uci add_list wireless.radio0.basic_rate='18000'
echo -n "."; uci add_list wireless.radio0.basic_rate='36000'
echo -n "."; uci add_list wireless.radio0.basic_rate='54000'

echo -n "..."
if [ $1 ]
then
 uci set wireless.radio0.country='JP'
 uci set wireless.radio0.txpower='20'
 echo -n ".J..."
fi
echo "ok"

##3yecho -n "."; uci set gluon.wireless.outdoor='1'

##3yecho -n "."; uci set wireless.radio0.channel='13'
## echo -n "."; uci set wireless.radio0.country='DE'
##3yecho -n "."; uci set wireless.mesh_radio0.mesh_id='02:CA:FF:EE:BA:BE'
##3yecho "ok";   uci set wireless.client_radio0.ssid='www.freifunk-halle.org'

uci commit

v_respond=$(pidof respondd)
if [ $v_respond ]
then
 echo -n "WLAN restart...."
 wifi
 echo "ok"
fi

###########################################
if [ $v_respond ]
then
echo
echo "Falls der Router nicht wie erwartet normal funktionieren sollte,"
echo "bitte die laufenden Dienste ueberpruefen und ggf. neu starten. Im Zweifelsfall hilft reboot ..."
echo
else
echo
echo "Um alle Aenderungen zu uebernehmen, den Router bitte jetzt neu starten!"
echo "Dies laesst sich hier mit dem Kommando reboot erreichen."
echo
fi
###########################################
fi
